(* Copyright (C) 1987 Jensen & Partners International *)

(*$N,V-,I-,R-,A-,S-*)
IMPLEMENTATION MODULE EGA;
IMPORT Lib, SYSTEM, Str;
FROM IO IMPORT WrStrRedirect, RdStrRedirect;


TYPE
  tinyint = [0..7];
  bs = SET OF tinyint;
  bp = POINTER TO bs;

PROCEDURE GetMark(VAR line, column : CARDINAL);
  VAR r:SYSTEM.Registers;
 BEGIN
  r.AH:=3;
  r.BX:=0;
  Lib.Intr(r, 10H);
  line:=CARDINAL(r.DH);  column:=CARDINAL(r.DL);
 END GetMark;

 PROCEDURE SetMark ( line, column :CARDINAL );
  VAR r: SYSTEM.Registers;
 BEGIN
  r.DH:=SHORTCARD(line); r.DL:=SHORTCARD(column);
  r.BX:=0;
  r.AH:=2;
  Lib.Intr(r, 10H );
 END SetMark;

(* VAR  textcolor, backgroundcolor :CARDINAL;
 PROCEDURE TextColor(c : CARDINAL);
 BEGIN
  textcolor:=c
 END TextColor;

 PROCEDURE BackColor(c : CARDINAL);
 BEGIN
  backgroundcolor:=c
 END BackColor;*)

 PROCEDURE Scroll (left, up, right, down, color, number :CARDINAL);
  VAR reg: SYSTEM.Registers;
 BEGIN
  reg.AH:=06H;
  reg.AL:=SHORTCARD (number);
  reg.BH:=SHORTCARD (color);
  reg.CH:= SHORTCARD (up);   reg.CL:= SHORTCARD (left);
  reg.DH:= SHORTCARD (down);   reg.DL:=SHORTCARD (right);
  Lib.Intr ( reg, 10H );
 END Scroll;

 PROCEDURE write (ch :CHAR);
  VAR r:SYSTEM.Registers;
      s, c:CARDINAL;
 BEGIN
   GetMark( s, c);
  (* r.AH:=09H;
   r.AL:=SHORTCARD(' ');
   r.BH:= 0;
   r.BL:= SHORTCARD( BackgroundColor );
   r.CX:=1;
   Lib.Intr(r,10H);*)

   Scroll  (c, s, c, s, BackgroundColor, 0);
   r.AH:= 09H;
   r.AL:= SHORTCARD( ch );
   r.BH:= 0;
   r.BL:=  1<<7 + SHORTCARD((BITSET(TextColor) / BITSET(BackgroundColor)));
   r.CX:= 1;
   Lib.Intr(r,10H);

   IF    c<79 THEN  SetMark(s, c+1)
   ELSIF s<24 THEN  SetMark(s+1, 0)
   ELSE             SetMark( 0, 0)
   END;
 END write;

 PROCEDURE WriteString  (*$F*) (string: ARRAY OF CHAR);
  VAR i: CARDINAL;
      s, c :CARDINAL;
 BEGIN
  IF Str.Length (string) = 0 THEN RETURN END;
  FOR i:=0 TO Str.Length (string) -1   DO
     IF string[i]=CHAR(ORD(13)) THEN GetMark(s, c); SetMark(s, 0)
     ELSIF string[i]=CHAR(ORD(10)) THEN
         GetMark(s, c); SetMark((s+1) MOD 25,  c)
     ELSIF string[i]=CHAR(ORD( 8)) THEN
         GetMark(s, c);
         IF c>0 THEN SetMark(s, c-1)
         ELSIF s>0 THEN SetMark(s-1, 79)
         END;
     ELSE  write (string[i])
     END;
  END;
 END WriteString;

 PROCEDURE ReadAscii ():CHAR;
  VAR r: SYSTEM.Registers;
 BEGIN
  r.AH:=0H;
  Lib.Intr(r,16H);
  RETURN CHR(r.AL)
 END ReadAscii;

 PROCEDURE ReadString (*$F*)   (VAR string :ARRAY OF CHAR);
  VAR ch:CHAR;
      H,p, l,c :CARDINAL;
      line : ARRAY[0..82] OF CHAR;
 BEGIN
  H := HIGH(string);
  IF H>79 THEN H := 79 END;
  p := 0;
  LOOP
    ch := ReadAscii(); GetMark(l, c);
    IF ch=CHR(8)   THEN
         IF p>0 THEN
           IF c>0 THEN  SetMark(l, c-1)
           ELSIF l>0 THEN SetMark( l-1, 79)
           END;
           write(' ');  GetMark(l, c);
           IF c>0 THEN  SetMark(l, c-1)
           ELSIF l>0 THEN SetMark( l-1, 79)
           END;
           DEC(p);
         END;
    ELSIF (ch>=' ') THEN
      IF p<=H THEN
        write(ch);
        line[p] := ch;
        INC(p);
      END;
    ELSIF ch=CHR(13) THEN
      EXIT;
    END;
  END;
  line[p] := CHR(0);
  Str.Copy(string,line);
 END ReadString;

PROCEDURE GraphMode;
VAR r : SYSTEM.Registers;
BEGIN
  r.AX := 10H; (* for VGA change to 12H *)
  Lib.Intr( r,10H );
  WrStrRedirect := WriteString;
  RdStrRedirect := ReadString
END GraphMode;

PROCEDURE TextMode;
VAR r : SYSTEM.Registers;
BEGIN
  r.AX := 3;
  Lib.Intr( r,10H );
  WrStrRedirect := wstt;
  RdStrRedirect := rstt
END TextMode;

VAR Screen [0A000H:0] : ARRAY[0..0] OF bs;

PROCEDURE Plot( x,y,c : CARDINAL);
VAR
  t:bs;
  p,b,s:CARDINAL;
BEGIN
   IF (x < Width) AND (y < Depth) THEN
      b := 1 << (7-(x MOD 8));
      p := y*80+(x DIV 8);
      SYSTEM.Out( 3CEH,8);SYSTEM.Out( 3CFH,SHORTCARD(b));
      SYSTEM.Out( 3C4H,2);SYSTEM.Out( 3C5H,0FH);
      s := 0A000H;
      t := [s:p bp]^;
      [s:p bp]^ := bs{};
      SYSTEM.Out( 3C4H,2);SYSTEM.Out( 3C5H,SHORTCARD(c));
      [s:p bp]^ := bs{0..7};

      SYSTEM.Out( 3CEH,8);SYSTEM.Out( 3CFH,0FFH);
      SYSTEM.Out( 3C4H,2);SYSTEM.Out( 3C5H,0FH);
   END;
END Plot;

PROCEDURE Point(x,y:CARDINAL) : CARDINAL;
VAR
  t:bs;
  p,b,s:CARDINAL;
  c:CARDINAL;
BEGIN
  IF (x < Width) AND (y < Depth) THEN
    b := 1 << (7-(x MOD 8));
    p := y*80+(x DIV 8  );

    s := 0A000H;

    SYSTEM.Out( 3CEH, 4 ); (* read map sel *)

    SYSTEM.Out( 3CFH, 3 );
    t := [s:p bp]^;
    t := t * bs(b);
    c := CARDINAL( SHORTCARD(t) );

    SYSTEM.Out( 3CFH, 2 );
    t := [s:p bp]^;
    t := t * bs(b);
    c := c * 2 + CARDINAL( SHORTCARD(t) );

    SYSTEM.Out( 3CFH, 1 );
    t := [s:p bp]^;
    t := t * bs(b);
    c := c * 2 + CARDINAL( SHORTCARD(t) );

    SYSTEM.Out( 3CFH, 0 );
    t := [s:p bp]^;
    t := t * bs(b);
    c := c * 2 + CARDINAL( SHORTCARD(t) );

    c := c >> ( 7 - ( x MOD 8 ) );

    RETURN c;
  ELSE
    RETURN 0;
  END;
END Point;

PROCEDURE HLine ( x,y,x2 : CARDINAL; c:CARDINAL );
VAR c1,c2 : CARDINAL;
BEGIN
  IF y > Depth-1 THEN RETURN END;
  IF INTEGER(x) > Width-1 THEN RETURN END;
  IF INTEGER(x) < 0 THEN x := 0; END;
  IF x2 > Width-1 THEN x2 := Width-1 END;

(*  c1 := c MOD 16;
  c2 := c DIV 16;
  WHILE (x <= x2) DO
        IF ODD(x+y) THEN
           Plot( x  , y , c1 );
        ELSE
           Plot( x  , y , c2 );
        END;
        INC( x  );
  END;
  RETURN;
*)
  WHILE (x MOD 8 # 0)  AND (x <= x2) DO Plot( x  , y , c ); INC( x  ); END;
  WHILE (x2 MOD 8 # 7) AND (x <= x2) DO Plot( x2 , y , c ); DEC( x2 ); END;
  IF INTEGER(x) > INTEGER(x2) THEN RETURN; END;
  SYSTEM.Out( 3CEH,5);SYSTEM.Out( 3CFH,2);
  y := y*80;
  x := x DIV 8;
  x2 := x2 DIV 8;
  WHILE x <= x2 DO
    Screen[y+x] := bs(c);
    INC( x );
  END;
  SYSTEM.Out( 3CEH,5);SYSTEM.Out( 3CFH,0);
END HLine;

(*$C F0 *)

PROCEDURE Line(x1,y1,x2,y2: CARDINAL; c: CARDINAL);
VAR
  dx,dy,e,tmp : INTEGER;
BEGIN
  IF x1 > x2 THEN (* ensure that x2 >= x1 *)
    tmp := x1; x1 := x2; x2 := tmp;
    tmp := y1; y1 := y2; y2 := tmp;
  END;

  dx := x2-x1;
  e  := 0;
  IF y1 <= y2 THEN (* case where y increases *)
    dy := (y2-y1);
    IF dx >= dy THEN
      LOOP
        Plot( x1,y1,c );
        IF x1 = x2 THEN EXIT END;
        INC(x1);
        INC(e,dy);
        INC(e,dy);
        IF e > dx THEN
          DEC(e,dx);
          DEC(e,dx);
          INC(y1);
        END;
      END;
    ELSE
      LOOP
        Plot( x1,y1,c );
        IF y1 = y2 THEN EXIT END;
        INC(y1);
        INC(e,dx);
        INC(e,dx);
        IF e > dy THEN
          DEC(e,dy);
          DEC(e,dy);
          INC(x1);
        END;
      END;
    END;
  ELSE
    (* case where y decreases *)
    dy := (y1-y2);
    IF dx >= dy THEN
      LOOP
        Plot( x1,y1,c );
        IF x1 = x2 THEN EXIT END;
        INC(x1);
        INC(e,dy);
        INC(e,dy);
        IF e > dx THEN
          DEC(e,dx);
          DEC(e,dx);
          DEC(y1);
        END;
      END;
    ELSE
      LOOP
        Plot( x1,y1,c );
        IF y1 = y2 THEN EXIT END;
        DEC(y1);
        INC(e,dx);
        INC(e,dx);
        IF e > dy THEN
          DEC(e,dy);
          DEC(e,dy);
          INC(x1);
        END;
      END;
    END;
  END;
END Line;


CONST
  dx = 2;
  dy = 2;

PROCEDURE Disc(x0,y0,r: CARDINAL; c: CARDINAL);
VAR
  e   : INTEGER;
  x,y : CARDINAL;
BEGIN
  x := r; y := 0; e := 0;
  WHILE INTEGER(y) <= INTEGER(x) DO
    HLine(x0-x,y0+y,x0+x,c);
    HLine(x0-x,y0-y,x0+x,c);
    INC(y);
    INC(e,y*dy-1);
    IF e > INTEGER(x) THEN
      DEC(x);
      DEC(e,x*dx+1);
      HLine(x0-y,y0+x,x0+y,c);
      HLine(x0-y,y0-x,x0+y,c);
    END;
  END;
END Disc;

PROCEDURE Circle(x0,y0,r: CARDINAL; c: CARDINAL);
VAR
  e   : INTEGER;
  x,y : CARDINAL;
BEGIN
  x := r; y := 0; e := 0;
  WHILE INTEGER(y) <= INTEGER(x) DO
    Plot(x0+x,y0+y,c);
    Plot(x0-x,y0+y,c);
    Plot(x0+x,y0-y,c);
    Plot(x0-x,y0-y,c);
    Plot(x0+y,y0+x,c);
    Plot(x0-y,y0+x,c);
    Plot(x0+y,y0-x,c);
    Plot(x0-y,y0-x,c);
    INC(y);
    INC(e,y*dy-1);
    IF e > INTEGER(x) THEN
      DEC(x);
      DEC(e,x*dx+1);
    END;
  END;
END Circle;

PROCEDURE Polygon(n: CARDINAL; px,py: ARRAY OF CARDINAL; c: CARDINAL);
CONST
  MaxPts = 20;
VAR
  y,miny,maxy,x0,y0,x1,y1,temp,i,edge,next_edge,active : INTEGER;
  xord : ARRAY [0..MaxPts] OF INTEGER;
  x    : ARRAY [0..MaxPts] OF CARDINAL;
  e    : ARRAY [0..MaxPts] OF INTEGER;

PROCEDURE quicksort(l,r: INTEGER);
VAR
  i,j,temp : INTEGER;
  key : CARDINAL;
BEGIN
  WHILE ( l < r ) DO
    i := l; j := r; key := x[xord[j]];
    REPEAT
      WHILE ( i < j ) AND ( x[xord[i]] <= key ) DO i := i + 1 END;
      WHILE ( i < j ) AND ( key <= x[xord[j]] ) DO j := j - 1 END;
      IF i < j THEN
        temp := xord[i]; xord[i] := xord[j]; xord[j] := temp;
      END;
    UNTIL ( i >= j );
    temp := xord[i]; xord[i] := xord[r]; xord[r] := temp;
    IF (i-l < r-i) THEN
      quicksort( l, i-1 ); l := i+1;
    ELSE
      quicksort( i+1, r ); r := i-1;
    END;
  END;
END quicksort;

BEGIN
  IF n > MaxPts THEN n := MaxPts END;

  (* find extremal y points *)
  miny := py[0]; maxy := miny;
  FOR i := 0 TO n-1 DO
    IF INTEGER(py[i]) < miny THEN miny := py[i]; END;
    IF INTEGER(py[i]) > maxy THEN maxy := py[i]; END;
  END;

  FOR y := miny TO maxy DO
    active := -1;
    FOR edge := 0 TO n-1 DO
      IF edge = INTEGER(n-1) THEN next_edge := 0 ELSE next_edge := edge + 1; END;
      x0 := px[edge]; y0 := py[edge];
      x1 := px[next_edge]; y1 := py[next_edge];
      IF y0 > y1 THEN temp := x0; x0 := x1; x1 := temp;
                      temp := y0; y0 := y1; y1 := temp END;
      IF y = y0 THEN e[edge] :=  0; x[edge] := x0
      ELSIF ( y0 <= y ) AND ( y <= y1 ) THEN
        IF x1 >= x0 THEN (* x increases with y *)
          INC( e[edge], 2*(x1-x0) );
          WHILE e[edge] > INTEGER(y1-y0) DO
            DEC( e[edge], 2*(y1-y0) ); INC(x[edge]);
          END;
        ELSE (* x decreases with y *)
          INC( e[edge], 2*(x0-x1) );
          WHILE e[edge] > INTEGER(y1-y0) DO
            DEC( e[edge], 2*(y1-y0) ); DEC(x[edge]);
          END;
        END;
        active := active + 1;
        xord[active] := edge;
      END;
    END;
    quicksort(0,active);
    i := 0;
    WHILE i < active DO
      HLine( x[xord[i]], y, x[xord[i+1]], c );
      i := i + 2;
    END;
  END; (* for y := .. *)
END Polygon;

(*

VAR Continue:PROC;
(*$F*)
PROCEDURE Finish;
BEGIN
  TextMode;
  Continue;
END Finish;

BEGIN
  Lib.Terminate( Finish, Continue );
*)
BEGIN
 wstt:=WrStrRedirect; rstt:=RdStrRedirect;
 TextColor:=7;
 BackgroundColor:=1;
END EGA.

