IMPLEMENTATION MODULE PullUp;
  FROM Window IMPORT WinDef,Open,SetTitle,Info,Change,Use,Clear,
                     GotoXY,TextBackground,TextColor,PutOnTop,CursorOff,
                     Color,SingleFrame,Close,Hide,PaletteOpen,
                     SetPaletteColor,ClrEol;
  FROM IO IMPORT WrChar,WrStr,RdKey,WrLn,WrCard;
  FROM Str IMPORT Length,Slice,Copy,Delete,Append,StrToCard,Pos;
  FROM Storage IMPORT ALLOCATE,DEALLOCATE;
  FROM MYLIB IMPORT NotSpace,Cap,CapNotSpace,ColorToCard,CardToColor,FirstCapPos;
  IMPORT FIO;

  CONST Nonsens=MAX(CARDINAL);

  TYPE STRING=ARRAY[0..79] OF CHAR;
       MenuSys=ARRAY[1..255] OF POINTER TO RECORD
                 T:STRING;
                 TM:TitleMode;
                 MD:MenuDef;
                 W:WinType;
                 O:ARRAY[1..79] OF POINTER TO RECORD
                     NM:STRING;
                     BF,AF:PROC;
                     SM:Menu
                   END;
                 P,MP:CARDINAL;
                 BK,NT,PV:Menu
               END;

  VAR MS:MenuSys;
      Count:CARDINAL;
      Exit,Return:BOOLEAN;

  PROCEDURE SetTitleMenu(M:Menu;Title:ARRAY OF CHAR;TMode:TitleMode);
  BEGIN Copy(MS[M]^.T,Title); MS[M]^.TM:=TMode
  END SetTitleMenu;

  PROCEDURE SetPosMenu(M:Menu;N:CARDINAL);
  BEGIN MS[M]^.P:=N
  END SetPosMenu;

  PROCEDURE SetBackCom(M:Menu; Back:Menu);
  BEGIN MS[M]^.BK:=Back
  END SetBackCom;

  PROCEDURE SetHorCom(Prev,Next:Menu);
  BEGIN MS[Prev]^.NT:=Next; MS[Next]^.PV:=Prev
  END SetHorCom;

  PROCEDURE AddOptionMenu(M:Menu;Name:ARRAY OF CHAR;Before,After:PROC;SubMenu:Menu);
  BEGIN
    WITH MS[M]^ DO
      INC(MP);IF P=0 THEN P:=1 END;
      NEW(O[MP]);
      WITH O[MP]^ DO Copy(NM,Name); BF:=Before; AF:=After; SM:=SubMenu END
    END
  END AddOptionMenu;

  PROCEDURE ChangeMenu(M:Menu;MDef:MenuDef);
  BEGIN MS[M]^.MD:=MDef
  END ChangeMenu;

  PROCEDURE ExitProc;
  BEGIN Exit:=TRUE END ExitProc;

  PROCEDURE ReturnProc;
  BEGIN Exit:=TRUE; Return:=TRUE END ReturnProc;

  PROCEDURE NoDeal;
  BEGIN END NoDeal;

  PROCEDURE InitWin(M:Menu);
    VAR WD:WinDef;
  BEGIN
    WITH MS[M]^ DO
      WD.X1:=MD.X1;WD.X2:=MD.X2;WD.Y1:=MD.Y1;WD.Y2:=MD.Y2;
      IF (MD.T=PopUp)&((MD.F&(MP<MD.Y2-MD.Y1-1))OR((NOT MD.F)&(MP<MD.Y2-MD.Y1+1)))
      THEN WD.Y2:=MD.Y1+MP+1 END;
      WD.CursorOn:=FALSE; WD.WrapOn:=FALSE; WD.Hidden:=FALSE;
      WD.FrameOn:=MD.F; WD.FrameDef:=MD.FD;
      W:=PaletteOpen(WD,MD.P);
      SetTitle(W,T,TM)
    END
  END InitWin;

  PROCEDURE Draw(M:Menu; Active:BOOLEAN);
    VAR PP,I:CARDINAL; B:BOOLEAN; S:STRING;
  BEGIN
    WITH MS[M]^ DO
      IF W=NIL THEN InitWin(M) END;
      Use(W);
      Clear;
      FOR I:=1 TO MP DO
        WITH O[I]^ DO
          PP:=Pos(NM,Mark);
          B:=Active&(I=P);
          IF PP=Nonsens THEN
             IF B THEN SetPaletteColor(3) ELSE SetPaletteColor(0) END;
             WrStr(NM)
          ELSE Slice(S,NM,0,PP);
             IF B THEN SetPaletteColor(3) ELSE SetPaletteColor(0) END;
             WrStr(S);
             IF B THEN SetPaletteColor(4) ELSE SetPaletteColor(2) END;
             WrChar(NM[PP+1]);
             Slice(S,NM,PP+2,Length(NM)-PP-2);
             IF B THEN SetPaletteColor(3) ELSE SetPaletteColor(0) END;
             WrStr(S);
          END
        END;
        ClrEol;
        IF (MD.T=PopUp)&(I<MP) THEN WrLn END
      END
    END
  END Draw;

  PROCEDURE InitMenu(MDef:MenuDef):Menu;
    VAR M:Menu; WD:WinDef;
  BEGIN
    INC(Count);
    NEW(MS[Count]);
    WITH MS[Count]^ DO T:=''; MD:=MDef; P:=0; MP:=0; BK:=0; NT:=0; PV:=0; W:=NIL END;
    RETURN Count
  END InitMenu;

  PROCEDURE AskMenu(M:Menu; VAR MenuNum,PosNum:CARDINAL):BOOLEAN;
    VAR C:CHAR;
  BEGIN
    Exit:=FALSE; Return:=FALSE;
    LOOP Draw(M,TRUE);
         WITH MS[M]^ DO
           C:=RdKey();
           IF ORD(C)=0 THEN C:=RdKey();
              CASE ORD(C) OF
              72:IF MD.T=PopUp THEN IF P>1 THEN DEC(P) ELSE P:=MP END
                 ELSIF PV#0 THEN Close(W); M:=PV; InitWin(M) END  |
              80:IF MD.T=PopUp THEN IF P<MP THEN INC(P) ELSE P:=1 END
                 ELSIF NT#0 THEN Close(W); M:=NT; InitWin(M) END  |
              75:IF MD.T=PullDn THEN IF P>1 THEN DEC(P) ELSE P:=MP END
                 ELSIF PV#0 THEN Close(W); M:=PV; InitWin(M) END  |
              77:IF MD.T=PullDn THEN IF P<MP THEN INC(P) ELSE P:=1 END
                 ELSIF NT#0 THEN Close(W); M:=NT; InitWin(M) END  |
              END
            ELSE CASE ORD(C) OF
                 27: IF BK=0 THEN IF MS[M]^.MD.H THEN Close(W)
                                  ELSE Draw(M,FALSE) END;
                                  RETURN FALSE
                     ELSE Close(W); M:=BK;InitWin(M) END          |
                 13: O[P]^.BF;
                     IF O[P]^.SM#0 THEN Close(W); M:=O[P]^.SM; InitWin(M) END;
                     O[P]^.AF                                           |
                 ELSE
                 END
           END;
           IF Exit THEN IF BK=0 THEN IF MS[M]^.MD.H THEN Close(W)
                                     ELSE Draw(M,FALSE) END;
                                     MenuNum:=M; PosNum:=P;
                                     RETURN TRUE
                        ELSE Close(W); M:=BK; InitWin(M);
                             IF NOT Return THEN Exit:=FALSE END
                        END
           END
         END
    END
  END AskMenu;

  PROCEDURE CardToMenuType(C:CARDINAL):MenuType;
  BEGIN
    IF C=0 THEN RETURN PopUp ELSE RETURN PullDn END
  END CardToMenuType;

  PROCEDURE MenuTypeToCard(T:MenuType):CARDINAL;
  BEGIN
    IF T=PopUp THEN RETURN 0
    ELSIF T=PullDn THEN RETURN 1 ELSE RETURN Nonsens END
  END MenuTypeToCard;

 (* PROCEDURE SaveMenu(M:Menu;NAME:ARRAY OF CHAR);
    VAR WD:WinDef;F:FIO.File;
  BEGIN
    F:=FIO.Create(NAME);
    WITH M^ DO
      Info(W,WD);
      FIO.WrCard(F,MenuTypeToCard(Type),1);FIO.WrChar(F,' ');
      FIO.WrCard(F,WD.X1,2);FIO.WrChar(F,' ');
      FIO.WrCard(F,WD.Y1,2);FIO.WrChar(F,' ');
      FIO.WrCard(F,ColorToCard(C1),2);FIO.WrChar(F,' ');
      FIO.WrCard(F,ColorToCard(C2),2);FIO.WrChar(F,' ');
      FIO.WrCard(F,ColorToCard(C3),2);FIO.WrChar(F,' ');
      FIO.WrCard(F,ColorToCard(C4),2);FIO.WrChar(F,' ');
      FIO.WrCard(F,ColorToCard(C5),2);FIO.WrChar(F,' ');
      FIO.WrCard(F,ColorToCard(C6),2);FIO.WrChar(F,' ');
      FIO.WrBool(F,WD.FrameOn,5);FIO.WrChar(F,' ');
      IF WD.FrameOn THEN
         FIO.WrCard(F,ColorToCard(WD.FrameFore),2);FIO.WrChar(F,' ');
         FIO.WrCard(F,ColorToCard(WD.FrameBack),2);FIO.WrChar(F,' ');
         FIO.WrStr(F,WD.FrameDef);
      END;
      FIO.WrLn(F)
    END;
    FIO.Close(F)
  END SaveMenu;

  PROCEDURE LoadMenu(NAME:ARRAY OF CHAR):Menu;
    VAR Type,X,Y,C1,C2,C3,C4,C5,C6,C7,C8:CARDINAL;
        Frame:BOOLEAN;
        Str:FrameStr;
        F:FIO.File;
  BEGIN
    IF FIO.Exists(NAME) THEN
      F:=FIO.Open(NAME);
      Type:=FIO.RdCard(F);X:=FIO.RdCard(F);Y:=FIO.RdCard(F);
      C1:=FIO.RdCard(F);C2:=FIO.RdCard(F);C3:=FIO.RdCard(F);
      C4:=FIO.RdCard(F);C5:=FIO.RdCard(F);C6:=FIO.RdCard(F);
      Frame:=FIO.RdBool(F);
      IF Frame THEN
         C7:=FIO.RdCard(F);C8:=FIO.RdCard(F);FIO.RdStr(F,Str);
      END;
      FIO.Close(F);
      RETURN InitMenu(CardToColor(C1),CardToColor(C2),CardToColor(C3),CardToColor(C4),
                      CardToColor(C5),CardToColor(C6),CardToColor(C7),CardToColor(C8),
                      CardToMenuType(Type),Frame,Str,X,Y)
    ELSE FIO.WrStr(FIO.StandardOutput,'  䠩 䨣樨'); RETURN NIL END
  END LoadMenu;*)

  PROCEDURE ClearMenu(M:Menu);
    VAR I:CARDINAL;
  BEGIN
    FOR I:=1 TO MS[M]^.MP DO DISPOSE(MS[M]^.O[I]) END;
    MS[M]^.MP:=0; MS[M]^.P:=0;
  END ClearMenu;

  PROCEDURE CloseMenuSys;
    VAR I,J:CARDINAL;
  BEGIN
    FOR I:=1 TO Count DO
      FOR J:=1 TO MS[I]^.MP DO
          IF MS[I]^.W#NIL THEN Close(MS[I]^.W) END; DISPOSE(MS[I]^.O[J])
      END;
      DISPOSE(MS[I])
    END
  END CloseMenuSys;

(*----------------------------------------------------------------------------*)

  PROCEDURE InitHelpStr(C1,C2,C3,C4:Color;Up:BOOLEAN):HelpStr;
    VAR WD:WinDef; H:HelpStr; i:CARDINAL;
  BEGIN
    WITH WD DO
      X1:=0; X2:=79; Foreground:=C1;Background:=C2;
      CursorOn:=FALSE;WrapOn:=FALSE;Hidden:=TRUE;FrameOn:=FALSE;
      IF Up THEN Y1:=0; Y2:=0 ELSE Y1:=24;Y2:=24 END;
    END;
    H:=Open(WD); Use(H);TextColor(C3);TextBackground(C4);
    FOR i:=1 TO 9 DO GotoXY(8*(i-1)+1,1); WrChar('F'); WrCard(i,1) END;
    GotoXY(73,1); WrChar('F'); WrCard(10,2);
    TextColor(C1);TextBackground(C2);Hide(H);
    RETURN H
  END InitHelpStr;


  PROCEDURE AddInfoHelp(H:HelpStr;N:CARDINAL;S:SHORTSTR);
  BEGIN
    Use(H);IF N=10 THEN GotoXY(76,1) ELSE GotoXY(8*(N-1)+3,1) END; WrStr(S)
  END AddInfoHelp;

  PROCEDURE ShowHelpStr(H:HelpStr);
  BEGIN PutOnTop(H) END ShowHelpStr;

  PROCEDURE HideHelpStr(H:HelpStr);
  BEGIN Hide(H) END HideHelpStr;

  PROCEDURE CloseHelpStr(VAR H:HelpStr);
  BEGIN Close(H) END CloseHelpStr;

(*--------------------------------------------------------------------------*)

(*  PROCEDURE AskColorMenu(Type:ColorType;Col:Color):Color;
    VAR W1,W2:WinType;I,J:CARDINAL;
        C:LONGCARD;
        M:Menu;
        S:ARRAY[0..7] OF CHAR;
        StatusStr:ARRAY[0..2] OF CHAR;
        OK:BOOLEAN;
 BEGIN
    W1:=Open(WinDef(6,4,71,8,Black,LightGray,FALSE,FALSE,FALSE,TRUE,SingleFrame,Black,LightGray));
    IF Type=Fore THEN SetTitle(W1,'    ',CenterUpperTitle)
    ELSE SetTitle(W1,'    ',CenterUpperTitle) END;
    W2:=Open(WinDef(7,5,70,6,Black,Black,FALSE,FALSE,FALSE,FALSE,SingleFrame,Black,Black));
    FOR J:=1 TO 2 DO
        FOR I:=0 TO 15-8*ORD(Type) DO
            GotoXY((4+4*ORD(Type))*I+1,J);
            IF Type=Fore THEN TextColor(CardToColor(I));WrStr('')
            ELSE TextBackground(CardToColor(I));WrStr('        ') END
        END
    END;
    M:=InitMenu(LightGray,LightGray,LightGray,Black,Black,LightGray,Black,Black,PullDn,FALSE,SingleFrame,7,7);
    IF Type=Fore THEN Copy(S,'   ') ELSE Copy(S,'       ') END;
    FOR I:=0 TO 7 DO AddOptionMenu(M,S,ExitProc,NoSUBMENU) END;
    IF Type=Fore THEN FOR I:=8 TO 15 DO AddOptionMenu(M,S,ExitProc,NoSUBMENU) END END;
    SetPosMenu(M,ColorToCard(Col)+1);
    AskMenu(M,StatusStr);
    Delete(StatusStr,1,1);
    C:=StrToCard(StatusStr,10,OK);
    Close(W1);Close(W2);CloseMenu(M);
    RETURN CardToColor(CARDINAL(C))
  END AskColorMenu;*)

BEGIN
  Mark:='@';
  Count:=0;
  Exit:=FALSE;
  Return:=FALSE;
  FIO.IOcheck:=FALSE;
END PullUp.