IMPLEMENTATION MODULE TM;
  FROM IO IMPORT WrChar,WrCard,WrStr,RdKey,KeyPressed,WrLn;
  FROM Storage IMPORT ALLOCATE,DEALLOCATE;
  FROM Window IMPORT WinDef,Color,Open,Use,TextColor,Clear,Close,
                     SingleFrame,GotoXY,SetTitle,LeftUpperTitle,CursorOn,
                     PutOnTop,Hide,
                     PaletteOpen,PaletteColorDef,SetPaletteColor;
  FROM Str IMPORT Copy,ItemS,Insert;
  FROM Clock IMPORT Time,GetTime;
  FROM Messages IMPORT Error,Message,Report;
  FROM Dialog IMPORT RdLine,All;

(*- 設-----------------------------------------------------------*)

   PROCEDURE WCa(C:CARDINAL);
   BEGIN SetPaletteColor(2); IF C<10 THEN WrChar('0'); WrCard(C,1) ELSE WrCard(C,2) END
   END WCa;

   PROCEDURE WCh(C:CHAR);
   BEGIN SetPaletteColor(3); WrChar(C)
   END WCh;

   PROCEDURE WSt(S:ARRAY OF CHAR);
   BEGIN SetPaletteColor(0); WrStr(S)
   END WSt;

   PROCEDURE WSd(cm:Command);
   BEGIN SetPaletteColor(4);
         CASE cm OF
         R: WrChar('R')|
         L: WrChar('L')|
         E: WrChar(' ')|
         END
   END WSd;

   PROCEDURE InitWin(T:TMachine);
     VAR WD:WinDef; i:CARDINAL;
   BEGIN
     IF T#NIL THEN
        WITH T^ DO
          WITH WD DO
            X1:=15; X2:=64; Y1:=2; Y2:=18; Foreground:=Black; Background:=LightGray;
            CursorOn:=FALSE; WrapOn:=FALSE; Hidden:=FALSE;
            FrameOn:=TRUE; FrameDef:=SingleFrame; FrameFore:=Black; FrameBack:=LightGray
          END;
          IF W#NIL THEN Close(W) END;
          W:=PaletteOpen(WD,Palette); SetTitle(W,Name,LeftUpperTitle);
          FOR i:=1 TO Max DO
            WITH R[i]^ DO
              GotoXY(4*ORD(i<=6)+20*ORD((i>6)&(i<=12))+36*ORD(i>12),(i-1) MOD 6+2);
              WSt('Q'); WCa(Source); WSt('S'); WCh(In); WSt(CHR(26));
              WSt('Q'); WCa(Target); WSt('S'); WCh(Out); WSd(cm)
            END
          END;
          GotoXY(2,9); WSt('砫쭮 ﭨ      '); WCa(So);
          GotoXY(2,10); WSt('⥫쭮 ﭨ '); WCa(Sz);
          GotoXY(2,12); WSt('饥 ﭨ ');
          GotoXY(2,13); WSt('室 ᨬ    ');
          GotoXY(2,14); WSt('室 ᨬ   ');
        END
     END
   END InitWin;

   PROCEDURE InitAdd2M():TMachine;
     TYPE AR=ARRAY[1..6] OF RoolRec;
     CONST RL=AR(RoolRec('*',' ',1,4,R),RoolRec('1',' ',1,2,R),RoolRec('1','1',2,2,R),
                 RoolRec('*','1',2,3,L),RoolRec('1','1',3,3,L),RoolRec(' ',' ',3,4,R));
     VAR I:CARDINAL; T:TMachine;
   BEGIN
     NEW(T);
     WITH T^ DO
       Copy(Name,'  ᥫ'); W:=NIL;
       Max:=6; So:=1; Sz:=4; A:=CHARSET{'*','1',' '}; Cur:=1;
       FOR I:=1 TO 6 DO NEW(R[I]); R[I]^:=RL[I] END;
     END;
     InitWin(T);
     RETURN T
   END InitAdd2M;

   PROCEDURE InitAddNM():TMachine;
     TYPE AR=ARRAY[1..11] OF RoolRec;
     CONST RL=AR(RoolRec('1',' ',1,2,R),RoolRec('*',' ',1,4,R),RoolRec('1','1',2,2,R),
                 RoolRec('*','1',2,4,R),RoolRec('1','1',3,3,L),RoolRec(' ',' ',3,1,R),
                 RoolRec('1','1',4,4,R),RoolRec('*','*',4,3,L),RoolRec(' ',' ',4,5,L),
                 RoolRec('1','1',5,5,L),RoolRec(' ',' ',5,6,R));
     VAR I:CARDINAL; T:TMachine;
   BEGIN
     NEW(T);
     WITH T^ DO
       Copy(Name,' N ᥫ'); W:=NIL;
       Max:=11; So:=1; Sz:=6; A:=CHARSET{'*','1',' '}; Cur:=1;
       FOR I:=1 TO 11 DO NEW(R[I]); R[I]^:=RL[I] END;
     END;
     InitWin(T);
     RETURN T
   END InitAddNM;

   PROCEDURE InitCopyM():TMachine;
     TYPE AR=ARRAY[1..12] OF RoolRec;
     CONST RL=AR(RoolRec('1','0',1,2,R),RoolRec(' ',' ',1,5,R),RoolRec('*','*',1,1,L),
                 RoolRec('0','1',1,1,L),RoolRec('1','1',2,2,R),RoolRec(' ','*',2,3,R),
                 RoolRec('*','*',2,3,R),RoolRec('1','1',3,3,R),RoolRec(' ','1',3,4,L),
                 RoolRec('1','1',4,4,L),RoolRec('*','*',4,4,L),RoolRec('0','0',4,1,R));
     VAR I:CARDINAL; T:TMachine;
   BEGIN
     NEW(T);
     WITH T^ DO
       Copy(Name,'஢ ᫠'); W:=NIL;
       Max:=12; So:=1; Sz:=5; A:=CHARSET{'*','1','0',' '}; Cur:=1;
       FOR I:=1 TO 12 DO NEW(R[I]); R[I]^:=RL[I] END;
     END;
     InitWin(T);
     RETURN T
   END InitCopyM;

   PROCEDURE InitOddM():TMachine;
     TYPE AR=ARRAY[1..10] OF RoolRec;
     CONST RL=AR(RoolRec('1','1',1,3,R),RoolRec(' ','',1,6,E),RoolRec('1','1',2,3,R),
                 RoolRec(' ',' ',2,4,L),RoolRec('1','1',3,2,R),RoolRec(' ',' ',3,5,L),
                 RoolRec('1',' ',4,4,L),RoolRec(' ','',4,6,E),RoolRec('1',' ',5,5,L),
                 RoolRec(' ','',5,6,E));
     VAR I:CARDINAL; T:TMachine;
   BEGIN
     NEW(T);
     WITH T^ DO
       Copy(Name,'। ⭮ ᫠'); W:=NIL;
       Max:=10; So:=1; Sz:=6; A:=CHARSET{'','','1',' '}; Cur:=1;
       FOR I:=1 TO 10 DO NEW(R[I]); R[I]^:=RL[I] END;
     END;
     InitWin(T);
     RETURN T
   END InitOddM;

   PROCEDURE InitM(S:ARRAY OF CHAR):TMachine;
     VAR T:TMachine;
   BEGIN
     NEW(T);
     WITH T^ DO
       Max:=1; Copy(Name,S);
       W:=NIL; So:=1; Sz:=1; A:=CHARSET{' '};
       NEW(R[1]);
       WITH R[1]^ DO
         In:=' '; Out:=' '; Source:=1; Target:=1; cm:=L
       END;
     END;
     InitWin(T);
     RETURN T
   END InitM;

   PROCEDURE SetTitleM(T:TMachine;S:ARRAY OF CHAR);
   BEGIN WITH T^ DO Copy(Name,S); SetTitle(W,S,LeftUpperTitle) END
   END SetTitleM;

(*-  設--------------------------------------------------------*)

   PROCEDURE SortRool(T:TMachine);
    VAR I,J:CARDINAL;
        RP:RoolPtr;
   BEGIN
     IF T^.Max>1 THEN
        WITH T^ DO
          FOR I:=Max TO 2 BY -1 DO
            FOR J:=1 TO I-1 DO
              IF (R[J+1]^.Source<R[J]^.Source)OR((R[J+1]^.Source=R[J]^.Source)&(R[J+1]^.In<R[J]^.In))
              THEN RP:=R[J]; R[J]:=R[J+1]; R[J+1]:=RP END
     END END END END
   END SortRool;

   PROCEDURE FindId(T:TMachine;Q:CARDINAL;C:CHAR;VAR Id:CARDINAL):CARDINAL;
   BEGIN
     WITH T^ DO
       IF Q>99 THEN RETURN 0 END;
       IF NOT (C IN A) THEN RETURN 1 END;
       Id:=1;
       WHILE (Id<=Max)& NOT((R[Id]^.Source=Q)&(R[Id]^.In=C)) DO INC(Id) END;
       IF Id>Max THEN RETURN 2 ELSE RETURN 0 END;
     END
   END FindId;

   PROCEDURE Display(T:TMachine; I:CARDINAL);
     VAR i:CARDINAL;
   BEGIN
     IF T#NIL THEN
        WITH T^ DO
          Use(W); SetPaletteColor(5);
          FOR i:=1 TO Max DO
            GotoXY(2*ORD(i<=6)+18*ORD((i>6)&(i<=12))+34*ORD(i>12),(i-1) MOD 6+2);
            IF i=I THEN WrChar(CHR(251)) ELSE WrChar(' ') END;
          END;
          IF (I>0)&(I<=Max) THEN
             WITH R[I]^ DO
               GotoXY(20,12);
               IF Source<10 THEN WrChar('0'); WrCard(Source,1)
               ELSE WrCard(Source,2) END;
               WrChar(CHR(26));
               IF Target<10 THEN WrChar('0'); WrCard(Target,1)
               ELSE WrCard(Target,2) END;
               GotoXY(20,13); WrChar(In);
               GotoXY(20,14); WrChar(Out)
             END
          END
        END
     END
   END Display;

   PROCEDURE EditM(T:TMachine);
     VAR F,FF,Id:CARDINAL; C:CHAR; P:RoolPtr;
         S:ARRAY[0..47] OF CHAR;
   BEGIN
     IF T#NIL THEN
        F:=0; FF:=0; Id:=1;
        Message(2); InitWin(T);
        Use(T^.W); CursorOn; GotoXY(27,9); WCa(T^.So); GotoXY(27,9);
        REPEAT C:=RdKey();
               IF C=CHR(0) THEN C:=RdKey();
                  CASE ORD(C) OF
                  75: CASE F OF
                      0: IF T^.So>1 THEN DEC(T^.So) END|
                      1: IF T^.Sz>1 THEN DEC(T^.Sz) END|
                      2: IF FF>0 THEN DEC(FF) END | END|
                  77: CASE F OF
                      0: IF T^.So<99 THEN INC(T^.So) END|
                      1: IF T^.Sz<99 THEN INC(T^.Sz) END|
                      2: IF FF<4 THEN INC(FF) END       |
                      END|
                  72: IF (F=2)&(Id>1) THEN
                         IF Id=T^.Max THEN Message(0) END; DEC(Id);
                      END|
                  80: IF F=2 THEN
                         IF Id<T^.Max THEN
                            INC(Id); IF Id=T^.Max THEN Message(1) END
                         ELSIF T^.Max<MaxRoolNum
                         THEN INC(Id); INC(T^.Max); NEW(T^.R[Id]);
                              WITH T^.R[Id]^ DO In:=' '; Out:=' '; Source:=1; Target:=1; cm:=L
                              END;
                              InitWin(T); CursorOn
                         END
                      END|
                  83: IF (F=2)&(T^.Max>1)&(Id=T^.Max) THEN
                          P:=T^.R[Id]; DISPOSE(P); T^.R[Id]:=NIL;
                          DEC(Id); DEC(T^.Max); InitWin(T); CursorOn
                      END|
                  END
               ELSE IF ORD(C)=9 THEN
                       IF F<3 THEN INC(F) ELSE F:=0 END;
                       IF F=3 THEN
                          Message(6);
                          Copy(S,T^.Name);
                          IF RdLine(S,16,2,Black,Cyan,All,TRUE,TRUE,FALSE)
                          THEN Copy(T^.Name,S) END;
                          SetTitleM(T,T^.Name);
                          F:=0
                       END;
                       IF F=2 THEN
                          IF Id=T^.Max THEN Message(1) ELSE Message(0) END
                       ELSE Message(2) END;
                    ELSE IF F=2 THEN
                            CASE FF OF
                            0: IF C IN CHARSET{'0'..'9'} THEN
                                  T^.R[Id]^.Source:=(T^.R[Id]^.Source MOD 10)*10+ORD(C)-48;
                               END|
                            1: IF C IN Set THEN T^.R[Id]^.In:=C END|
                            2: IF C IN CHARSET{'0'..'9'} THEN
                                  T^.R[Id]^.Target:=(T^.R[Id]^.Target MOD 10)*10+ORD(C)-48;
                               END|
                            3: IF C IN Set THEN T^.R[Id]^.Out:=C END|
                            4: CASE C OF
                               'E','e': T^.R[Id]^.cm:=E|
                               'R','r': T^.R[Id]^.cm:=R|
                               'L','l': T^.R[Id]^.cm:=L|
                               END|
                            END
                         END
                    END;
               END;
               Use(T^.W);
               CASE F OF
               0: GotoXY(27,9); WCa(T^.So); GotoXY(27,9)|
               1: GotoXY(27,10); WCa(T^.Sz); GotoXY(27,10)|
               2: CASE FF OF
                  0: GotoXY(5*ORD(Id<=6)+21*ORD((Id>6)&(Id<=12))+37*ORD(Id>12),(Id-1) MOD 6+2);
                     WCa(T^.R[Id]^.Source);
                     GotoXY(6*ORD(Id<=6)+22*ORD((Id>6)&(Id<=12))+38*ORD(Id>12),(Id-1) MOD 6+2)|
                  1: GotoXY(8*ORD(Id<=6)+24*ORD((Id>6)&(Id<=12))+40*ORD(Id>12),(Id-1) MOD 6+2);
                     WCh(T^.R[Id]^.In);
                     GotoXY(8*ORD(Id<=6)+24*ORD((Id>6)&(Id<=12))+40*ORD(Id>12),(Id-1) MOD 6+2)|
                  2: GotoXY(11*ORD(Id<=6)+27*ORD((Id>6)&(Id<=12))+43*ORD(Id>12),(Id-1) MOD 6+2);
                     WCa(T^.R[Id]^.Target);
                     GotoXY(12*ORD(Id<=6)+28*ORD((Id>6)&(Id<=12))+44*ORD(Id>12),(Id-1) MOD 6+2)|
                  3: GotoXY(14*ORD(Id<=6)+30*ORD((Id>6)&(Id<=12))+46*ORD(Id>12),(Id-1) MOD 6+2);
                     WCh(T^.R[Id]^.Out);
                     GotoXY(14*ORD(Id<=6)+30*ORD((Id>6)&(Id<=12))+46*ORD(Id>12),(Id-1) MOD 6+2)|
                  4: GotoXY(15*ORD(Id<=6)+31*ORD((Id>6)&(Id<=12))+47*ORD(Id>12),(Id-1) MOD 6+2);
                     WSd(T^.R[Id]^.cm);
                     GotoXY(15*ORD(Id<=6)+31*ORD((Id>6)&(Id<=12))+47*ORD(Id>12),(Id-1) MOD 6+2)|
                  END|
               END
        UNTIL ORD(C)=27;
        T^.A:=CHARSET{' '};
        FOR Id:=1 TO T^.Max DO INCL(T^.A,T^.R[Id]^.In); INCL(T^.A,T^.R[Id]^.Out) END;
        SortRool(T); InitWin(T);
     END
   END EditM;

   PROCEDURE OperateM(T:TMachine;O:OutPutDevice;I:InPutDevice;StepByStep:BOOLEAN);
     VAR N,ER:CARDINAL;
         C:CHAR;
   BEGIN
     IF T#NIL THEN
        IF StepByStep THEN Message(3) ELSE Message(4) END;
        T^.Cur:=T^.So;
        IF NOT StepByStep THEN GetTime(Start) END;
        LOOP ER:=FindId(T,T^.Cur,I(),N);
             Display(T,N);
             IF ER#0 THEN Error(ER); EXIT
             ELSE O(T^.R[N]^.Out,T^.R[N]^.cm);
                  T^.Cur:=T^.R[N]^.Target;
                  IF T^.Cur=T^.Sz THEN
                     IF StepByStep THEN Report(1)
                     ELSE GetTime(Finish); Report(2) END;
                     EXIT
                  END;
                  IF StepByStep THEN
                     REPEAT C:=RdKey() UNTIL (C=' ')OR(ORD(C)=27);
                     IF ORD(C)=27 THEN Error(3); EXIT END
                  ELSIF KeyPressed() THEN
                        C:=RdKey();
                        IF ORD(C)=27 THEN Error(3); EXIT END
                  END
             END
        END
     END
   END OperateM;

(*-⨥ 設-----------------------------------------------------------*)

   PROCEDURE CloseM(VAR T:TMachine);
     VAR I:CARDINAL;
   BEGIN
     IF T#NIL THEN
        WITH T^ DO
          FOR I:=1 TO Max DO DISPOSE(R[I]) END;
          Close(W)
        END;
        DISPOSE(T);
     END
   END CloseM;

BEGIN
  Palette:=PaletteDef(PaletteColorDef(Black,LightGray),
  PaletteColorDef(Black,LightGray),PaletteColorDef(Blue,LightGray),
  PaletteColorDef(Brown,LightGray),PaletteColorDef(Magenta,LightGray),
  PaletteColorDef(Red,LightGray),PaletteColorDef(Red,Red),
  PaletteColorDef(Red,Red),PaletteColorDef(Red,Red),PaletteColorDef(Red,Red));
END TM.