IMPLEMENTATION MODULE VIDEO;
  FROM AsmLib IMPORT Intr, Dos;
  FROM SYSTEM IMPORT Registers, Seg, Ofs;

  PROCEDURE GetCur(page:SHORTCARD; VAR x,y:SHORTCARD);
   VAR r:Registers;
  BEGIN
   WITH r DO AH:=03H; BH:=page; Intr(r,10H); x:=DL; y:=DH END;
  END GetCur;

  PROCEDURE PutCur( x,y,page:SHORTCARD);
   VAR r:Registers;
  BEGIN
   WITH r DO AH:=02H; BH:=page; DL:=x; DH:=y  END; Intr(r,10H);
  END PutCur;

  PROCEDURE SelectPage(page:SHORTCARD);
   VAR r:Registers;
  BEGIN
   WITH r DO AH:=05H; AL:=page END; Intr(r,10H);
  END SelectPage;

  PROCEDURE RdSign_Attr( VAR  x:CHAR; page:SHORTCARD; VAR attr:SHORTCARD);
   VAR r:Registers;
  BEGIN
   WITH r DO AH:=08H; BH:=page; Intr(r,10H); x:=CHR(AL); attr:=AH END;
  END RdSign_Attr;

  PROCEDURE WrSign_Attr(x:CHAR; attr,page:SHORTCARD;count:CARDINAL);
   VAR r:Registers;
  BEGIN
   WITH r DO AH:=09H; BH:=page; AL:=SHORTCARD(ORD(x)); CX:=count; BL:=attr; Intr(r,10H) END;
  END WrSign_Attr;

  PROCEDURE ReadVideoMode(VAR mode,page:SHORTCARD;column:CARDINAL);
   VAR r:Registers;
  BEGIN
   WITH r DO AH:=0FH; Intr(r,10H); mode:=AL; column:=CARDINAL(AH); page:=BH END;
  END ReadVideoMode;

  PROCEDURE SelectVideoMode(mode:SHORTCARD);
   VAR r:Registers;
  BEGIN
   WITH r DO AH:=00H; AL:=mode END; Intr(r,10H);
  END SelectVideoMode;

  PROCEDURE WindowMove(x1,y1,x2,y2,shift,attr:SHORTCARD; up_dn:BOOLEAN);
   VAR r:Registers;
  BEGIN
   WITH r DO CH:=y1; CL:=x1; DH:=y2; DL:=x2; AL:=shift; BH:=attr;
    IF up_dn THEN AH:=06H ELSE AH:=07H END; Intr(r,10H)
   END;
  END WindowMove;

  PROCEDURE Rd_Clear():CHAR;
   VAR r:Registers;
  BEGIN
   WITH r DO AH:=0BH; Dos(r);
       IF AL=0 THEN RETURN 0C
         ELSE AH:=0CH; AL:=08H; Dos(r);
           IF AL=0 THEN AH:=08H; Dos(r) END; RETURN CHR(AL)
   END END;
  END Rd_Clear;

  PROCEDURE RdPressedKey():CHAR;
   VAR r:Registers;
  BEGIN
   WITH r DO AH:=0BH; Dos(r);
       IF AL=0 THEN RETURN 0C
         ELSE AH:=08H; Dos(r);
           IF AL=0 THEN Dos(r) END; RETURN CHR(AL)
   END END;
  END RdPressedKey;

  PROCEDURE WrStrInPage(str:ARRAY OF CHAR; x,y,page,attr:SHORTCARD);
   VAR r:Registers;
  BEGIN
   WITH r DO AH:=13H; BH:=page; DL:=x; DH:=y; CX:=HIGH(str)+1;
      ES:=Seg(str); BP:=Ofs(str); AL:=1; BL:=attr
   END; Intr(r,10H);
  END WrStrInPage;

  PROCEDURE Print;
   VAR r:Registers;
  BEGIN
   Intr(r, 05H)
  END Print;

END VIDEO.
